package com.agilecontrol.nea.core.struts;

import com.agilecontrol.nea.core.control.web.WebUtils;
import com.agilecontrol.nea.core.struts.MessageResourcesFactory;
import com.agilecontrol.nea.core.struts.PropertyMessageResources;
import com.agilecontrol.nea.util.StringUtils;
import java.io.File;
import java.io.InputStream;
import java.net.URL;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Map;
import java.util.Properties;
import javax.servlet.ServletContext;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class MultiMessageResources extends PropertyMessageResources {

   private static final long serialVersionUID = -7711124186086748535L;
   private static Logger logger = LoggerFactory.getLogger(MultiMessageResources.class);
   private transient ServletContext _servletContext;


   public MultiMessageResources(MessageResourcesFactory factory, String config) {
      super(factory, config);
   }

   public MultiMessageResources(MessageResourcesFactory factory, String config, boolean returnNull) {
      super(factory, config, returnNull);
   }

   public Map getMessages() {
      return this.messages;
   }

   public void setServletContext(ServletContext servletContext) {
      this._servletContext = servletContext;
   }

   public static void main(String[] args) {
      String config = "E:/p.tlzys/act.nea/i18n";
      String[] names = StringUtils.split(config.replace('.', '/'));

      for(int i = 0; i < names.length; ++i) {
         String name = names[i];
         name = name + ".properties";
         System.out.println(name);
      }

   }

   protected void loadLocale(String localeKey) {
      HashMap names = this.locales;
      synchronized(this.locales) {
         if(this.locales.get(localeKey) != null) {
            return;
         }

         this.locales.put(localeKey, localeKey);
      }

      String[] var6 = StringUtils.split(this.config.replace('.', '/'));

      for(int i = 0; i < var6.length; ++i) {
         String name = var6[i];
         if(localeKey.length() > 0) {
            name = name + "_" + localeKey;
         }

         name = name + ".properties";
         this._loadProps(name, localeKey, false);
      }

   }

   private void _loadProps(String name, String localeKey, boolean useServletContext) {
      Properties props = new Properties();

      try {
         URL e = null;
         if(useServletContext) {
            e = this._servletContext.getResource("/WEB-INF/" + name);
         } else {
            String names = WebUtils.getProperty("dir.nea.root", true);
            File key = new File(names + File.separator + "i18n" + File.separator + name);
            if(key.exists()) {
               e = key.toURI().toURL();
            } else {
               logger.debug("Not find resource named " + name + key.getAbsolutePath());
            }
         }

         if(e != null) {
            InputStream names1 = e.openStream();
            props.load(names1);
            names1.close();
            if(logger.isInfoEnabled()) {
               logger.info("Loading " + e);
            }
         }
      } catch (Exception var9) {
         logger.warn(var9.getMessage(), var9);
      }

      if(props.size() >= 1) {
         HashMap e1 = this.messages;
         synchronized(this.messages) {
            Enumeration names2 = props.keys();

            while(names2.hasMoreElements()) {
               String key1 = (String)names2.nextElement();
               this.messages.put(this.messageKey(localeKey, key1), props.getProperty(key1));
            }

         }
      }
   }

}
